SystemOrganization addCategory: #GeoDSL!
SystemOrganization addCategory: #'GeoDSL-Examples'!
SystemOrganization addCategory: #'GeoDSL-Tests'!

TestCase subclass: #GeoDSLCompilerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Tests'!

!GeoDSLCompilerTests class methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:22'!
allMorphsSpec

	^'displayIn: myGraphics size: 1000@500    											
		(BorderedMorph lane1 size: 60@20 at: 300@100 bearing: 90 label: spur1)   
	   	(BorderedMorph lane2 size: 60@20 at: 375@100 label: spur2)				
		
		(BorderedMorph agv1 size: 22@10 at: 500@150 bearing: 10 label: agv1)   	
		(BorderedMorph agv2 size: 22@10 at: 500@180 bearing: 60 label: agv2)   
		
		(CircleMorph c1 size: 200@200 at: 400@300 bearing: 1 label: the_circle)   
		(GeoDSLCar a1 size: 32@10 at: 500@300 bearing: 90 label: car1)   			
		(EllipseMorph c2 size:  200@100 at: 400@300 bearing: 135 label: the_ellipse) 
		
		(polygon: bla [200@200 250@220 300@250 230@270] label: border)
		(polyline: blb [200@300 250@320 300@350 230@370] label: line)'! !

!GeoDSLCompilerTests class methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 14:11'!
allMorphsSpecWithComments

	^'  "GeoDSLExample new createFrom: self geoSpec" 
	displayIn: myGraphics size: 1000@500    											"defines the initial zoom"
		(BorderedMorph lane1 size: 60@20 at: 300@100 bearing: 90 label: spur1)      "first object" 
	   	(BorderedMorph lane2 size: 60@20 at: 375@100 label: spur2)				
		
		(BorderedMorph "even here you my place a comment" agv1 size: 22@10 at: 500@150 bearing: 10 label: agv1)   	
		(BorderedMorph agv2 size: 22@10 at: 500@180 bearing: 60 label: agv2)    	"fourth object"
		
		(CircleMorph c1 size: 200@200 at: 400@ "bad place for a comment" 300 bearing: 1 label: the_circle)   
		(GeoDSLCar a1 size: 32@10 at: 500@300 bearing: 90 label: car1)     			"sixth object"			
		(EllipseMorph c2 size:  200@100 at: 400@300 bearing: 135 label: the_ellipse) 
		
		(polygon: bla [200@200 250@220 300@250 230@270] label: border)
		(polyline: blb [200@300 250@320 300@350 230@370] label: line)
		
		"another comment" 
		'! !

!GeoDSLCompilerTests class methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 17:20'!
borderedMorphSpec

	^'displayIn: myGraphics size: 1000@500 (BorderedMorph lane1 size: 60@20 at: 300@100 bearing: 90 label: spur1)'! !

!GeoDSLCompilerTests class methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:12'!
borderedMorphsSpec

	^'displayIn: myGraphics size: 1000@500 (BorderedMorph lane1 size: 60@20 at: 300@100 bearing: 90 label: spur1) (BorderedMorph lane2 size: 60@20 at: 375@100 label: spur2) (BorderedMorph agv1 size: 22@10 at: 500@150 bearing: 10 label: agv1) (BorderedMorph agv2 size: 22@10 at: 500@180 bearing: 60 label: agv2)'! !

!GeoDSLCompilerTests class methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:16'!
borderedMorphsWithSpaceSpec

	^' displayIn:  myGraphics  size:  1000   @  500 
		(BorderedMorph   lane1  size:   60 @ 20   at:   300@100   bearing:   90   label:   spur1  ) 
		(BorderedMorph lane2 size: 60   @      20 at:      375     @     100      label: spur2) 
		(BorderedMorph agv1 size: 22@10 at: 500@150 bearing: 10 label: agv1) 
		(BorderedMorph   agv2   size:   22@10   at:   500@180   bearing:   60   label:   agv2)'! !

!GeoDSLCompilerTests class methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:18'!
ellipseMorphSpec

	^'displayIn: myGraphics size: 1000@500 (EllipseMorph  c2 size:  200@100 at: 400@300 bearing: 135 label: the_ellipse)'! !

!GeoDSLCompilerTests class methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:18'!
polygonMorphSpec

	^'displayIn: myGraphics size: 1000@500 (polygon: bla [200@200 250@220 300@250 230@270] label: border)'! !

!GeoDSLCompilerTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:01'!
setUp! !

!GeoDSLCompilerTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:23'!
testAllMorphs
	"multiple morphs - no space"
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests allMorphsSpec).
	self should: [result isKindOf: GeoDSLDrawing]! !

!GeoDSLCompilerTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 14:12'!
testAllMorphsWithComments
	"multiple morphs - no space"
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests allMorphsSpecWithComments).
	self should: [result isKindOf: GeoDSLDrawing]! !

!GeoDSLCompilerTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 15:48'!
testBorderedMorph
	"one morph - no space"
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).
	self should: [result isKindOf: GeoDSLDrawing].
	self should: [(result tMorphNamed:  'lane1' ) isKindOf: TransformationMorph ].
		self should: [(result morphNamed:  'lane1' )  isKindOf: BorderedMorph ]! !

!GeoDSLCompilerTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:13'!
testBorderedMorphs
	"multiple morphs - no space"
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphsSpec).
	self should: [result isKindOf: GeoDSLDrawing]! !

!GeoDSLCompilerTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:15'!
testBorderedMorphsWithSpace
	"multiple morphs - no space"
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphsWithSpaceSpec).
	self should: [result isKindOf: GeoDSLDrawing]! !

!GeoDSLCompilerTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:19'!
testEllipseMorph
	"one morph - no space"
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests ellipseMorphSpec).
	self should: [result isKindOf: GeoDSLDrawing]! !

!GeoDSLCompilerTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 13:19'!
testPolygonMorph
	"one morph - no space"
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests polygonMorphSpec).
	self should: [result isKindOf: GeoDSLDrawing]! !

GeoDSLCompilerTests subclass: #GeoDSLInterfaceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Tests'!

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 14:58'!
setUp! !

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 16:13'!
testAccess
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).		"get a drawing with one morph"
	self should: [(result objectNamed:  'lane1' )  isKindOf: GeoDSLObject  ].			"access object"
	self should: [(result tMorphNamed:  'lane1' ) isKindOf: TransformationMorph ].		"access tMorph "
	self should: [(result morphNamed:  'lane1' )  isKindOf: BorderedMorph ]			"access morph"

! !

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 16:12'!
testAddObj
	"add a non polygon Morph "
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).  "get a drawing with one morph"
	result add: #CircleMorph name: 'bla' size: 100@100 at: 0@0.
	self should: [(result morphNamed:  'bla' )  isKindOf: CircleMorph ].
! !

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 16:14'!
testAddPoly
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).			"get a drawing with one morph"
	result addPoly: 'bla' vertices: { 100@100  . 200@200 .  0@0} closed: true.		"add a Polygon"
	result addPoly: 'blb' vertices: { 100@100  . 200@200 .  0@0} closed: false.		"add a Polyline"
	self should: [(result objectNamed:  'bla' )  isKindOf: GeoDSLPathshape ].
	self should: [(result objectNamed:  'bla' )  closed = true].
	self should: [(result objectNamed:  'blb' )  isKindOf: GeoDSLPathshape ].
	self should: [(result objectNamed:  'blb' )  closed = false].
! !

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 16:14'!
testAddRemove
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).		"get a drawing with one morph"
	result add: ((GeoDSLObject new)
			morphClass: #BorderedMorph;
			name: 'blc' ;
			size: 100@100;
			location: 100@100;
			bearing: 0;
			yourself).
	self should: [(result objectNamed:  'blc' )  isKindOf: GeoDSLObject  ].				"access object"
	self should: [(result tMorphNamed:  'blc' ) isKindOf: TransformationMorph ].		"access tMorph "
	self should: [(result morphNamed:  'blc' )  isKindOf: BorderedMorph ].			   	"access morph"
	result removeObjectNamed: 'blc' .
	self should:  [(result objectNamed:  'blc' )  isKindOf: GeoDSLObject] raise: Error .	"access missing object"

! !

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 16:14'!
testChangeAngle
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).  "get a drawing with one morph"

	self shouldnt: [(result tMorphNamed:  'lane1' ) rotationDegrees = 10 ].	
	result change: 'lane1' at: #rotationDegrees: to: 10 .
	self should: [(result tMorphNamed:  'lane1' )  rotationDegrees = 10].

! !

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 16:13'!
testChangeColor
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).  "get a drawing with one morph"

	self shouldnt: [(result morphNamed:  'lane1' ) color = Color lightMagenta  ].	
	result change: 'lane1' at: #color: to: Color lightMagenta .
	self should: [(result morphNamed:  'lane1' ) color = Color lightMagenta  ].
! !

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 16:29'!
testMoveBy
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).  "get a drawing with one morph"

	self should: [(result objectNamed:  'lane1' ) location = (300@100)].					"bearing is 90 degrees (north)"
	result moveObject: 'lane1' by: 100 right: 10 .
	self should: [(result objectNamed:  'lane1' ) location = (300@0)].
	self should: [(result objectNamed:  'lane1' ) bearing = 80 degreesToRadians ].
! !

!GeoDSLInterfaceTests methodsFor: 'as yet unclassified' stamp: 'hk 2/13/2014 16:30'!
testMoveTo
	| result |
	result := GeoDSLCompiler compile: (GeoDSLCompilerTests borderedMorphSpec).  "get a drawing with one morph"

	self should: [(result objectNamed:  'lane1' ) location = (300@100) ].					"bearing is 90 degrees (north)"
	result moveObject: 'lane1' To: 100@200 bearing: 10 .
	self should: [(result objectNamed:  'lane1' ) location = (100@200) ].
	self should: [(result objectNamed:  'lane1' ) bearing = 10 degreesToRadians ].
! !

PPCompositeParser subclass: #GeoDSLGrammar
	instanceVariableNames: 'identifier integer point pointArray anyObject poly polygon polyline object graphics size location bearing label labelString comment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLGrammar commentStamp: '<historical>' prior: 0!
A GeoDSLGrammar for PetitParser!

GeoDSLGrammar subclass: #GeoDSLCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLCompiler commentStamp: '<historical>' prior: 0!
A GeoDSLCompiler for PetitParser
!

!GeoDSLCompiler class methodsFor: 'as yet unclassified' stamp: 'hk 1/14/2014 12:04'!
startSymbol
	"Answer the method that represents the default start symbol."

	^ #geoDSL! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 2/13/2014 12:19'!
anyObject
	^ super anyObject ==> [:n | n  at: 2 ] 
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/21/2014 16:35'!
bearing
	^ super bearing ==> [:n | n ifNil: [0 ] ifNotNil: [(n at: 2) inputValue asNumber degreesToRadians] ]
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/23/2014 13:04'!
graphics
	^ super graphics
		==> [:n | | r  |  (n at: 4) isEmpty  ifTrue: [  r := PPFailure message: 'no objects' at: 0  ]
				 ifFalse: [r := GeoDSLDrawing new: (n at: 2) inputValue.
						(n at: 4) do: [ :e | r  addToObjectDict:  e ]. 
						r createAllMorphsWithin: (n at: 3). ].	
				r ] 
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/26/2014 14:13'!
label
	^ super label ==> [:n | n ifNil: [ '' ] ifNotNil: [n at: 2 ] ]
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/26/2014 14:13'!
labelString
	^ super labelString ==> [ :n | n inputValue copyReplaceAll: '_' with: ' ' ]
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/15/2014 11:54'!
location
	^ super location ==> [:n | n at: 2] 
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/27/2014 17:08'!
object
	^ super object
		==> [:n | (GeoDSLObject new)
					morphClass:  (n at: 1) inputValue asSymbol;
					name:  (n at: 2) inputValue;
					size:  (n at:  3);		"migth still be nil"
					location:  (n at: 4);
					bearing:  (n at: 5);
					label:  (n at: 6);
					yourself ] 
		
! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/15/2014 12:13'!
point
	^ super point ==> [:n | Point x: (n at: 1) inputValue asInteger y: (n at: 3) inputValue asInteger]! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/16/2014 10:19'!
pointArray
	^ super pointArray
		==> [:n | |a| Array with: (n at: 2) withAll: (n at: 3)]  ! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/23/2014 12:56'!
poly
	^ super poly
		==> [:n | (GeoDSLPathshape vertices: (n at: 2)) 
					name: (n at: 1) inputValue;
					bearing: (n at: 3);
					label: (n at: 4);
				 	yourself]! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/20/2014 17:09'!
polygon
	^ super polygon ==> [:n | (n at: 2) 
								morphClass: #PolygonMorph;
				 				closed: true;
				 				yourself]! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/20/2014 17:09'!
polyline
	^ super polyline ==> [:n | (n at: 2) 
								morphClass: #PolygonMorph;
				 				closed: false;
								yourself]! !

!GeoDSLCompiler methodsFor: 'productions' stamp: 'hk 1/20/2014 14:23'!
size
	^ super size ==> [:n | n ifNil: [100@100 ] ifNotNil: [n at: 2] ]  ! !

!GeoDSLGrammar class methodsFor: 'as yet unclassified' stamp: 'hk 1/14/2014 12:05'!
compile:  aSpec
	^self parse: aSpec onError: [:msg :pos | self error: (msg, ' at: ', pos printString)]! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 2/13/2014 12:51'!
anyObject
	^ $( asParser trimC , (polygon / polyline / object) , $) asParser trimC  ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 2/13/2014 12:51'!
bearing
	^ ( 'bearing:' asParser, integer ) optional trimC! !

!GeoDSLGrammar methodsFor: 'basic rules' stamp: 'hk 2/13/2014 12:38'!
comment
	^ $" asParser , (PPPredicateObjectParser anyExceptAnyOf: '"') star, $" asParser! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/16/2014 10:47'!
geoDSL
	^ graphics end! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 2/13/2014 12:51'!
graphics
	^ 'displayIn:' asParser trimC , identifier , size, anyObject star! !

!GeoDSLGrammar methodsFor: 'basic rules' stamp: 'hk 2/13/2014 12:51'!
identifier
	^ (#letter asParser , #word asParser star) token trimC! !

!GeoDSLGrammar methodsFor: 'basic rules' stamp: 'hk 2/13/2014 12:52'!
integer
	^ ($- asParser optional, #digit asParser, #digit asParser star ) token trimC! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 2/13/2014 12:52'!
label
	^ ( 'label:' asParser , labelString ) optional trimC! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 2/13/2014 12:52'!
labelString
	^ ( (#word asParser | $_ asParser) star) token trimC! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 2/13/2014 12:52'!
location
	^ ('at:' asParser , point) trimC ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/27/2014 17:10'!
object
	^ identifier , identifier ,size ,  location , bearing , label ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/15/2014 18:02'!
point
	^ integer, $@ asParser, integer ! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 2/13/2014 12:52'!
pointArray
	"contains at least 2 points for polylines and polygons"
	^ ($[ asParser, point, point plus, $] asParser ) trimC! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/23/2014 12:55'!
poly
	"PolygonMorph will be used for polygons as well as polylines"
	^ identifier, pointArray, bearing, label! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/16/2014 10:33'!
polygon
	^ 'polygon:' asParser, poly! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 1/16/2014 10:34'!
polyline
	^ 'polyline:' asParser, poly! !

!GeoDSLGrammar methodsFor: 'rules' stamp: 'hk 2/13/2014 12:52'!
size
	^  (('size:' asParser, point) optional) trimC! !

!GeoDSLGrammar methodsFor: 'basic rules' stamp: 'hk 2/13/2014 12:54'!
trimC
	"trim comments too - simply use this instead of trim"
	^ self trim: (#space asParser | comment)! !

BorderedMorph subclass: #GeoDSLCar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!GeoDSLCar commentStamp: '<historical>' prior: 0!
A GeoDSLCar is a Morph.

Any GeoDSL morph must be created using Morph>>newBounds:
The private morph method privateBounds: must be complemented to construct the morph



!

!GeoDSLCar methodsFor: 'initialize-release' stamp: 'hk 1/26/2014 13:14'!
initializeMorph
	"construct a car"
	| wheel |
	self borderWidth: 2.
	self color: Color red.  "Ferrari"
	self useRoundedCorners.
	wheel := Rectangle origin: self bounds origin extent: self bounds extent / 7.
	self addMorph: ((Morph newBounds: wheel) center: self bounds origin + (3@0 * self width / 14); color: Color black).
	self addMorph: ((Morph newBounds: wheel) center: self bounds origin + (11@0 * self width / 14); color: Color black).
	self addMorph: ((Morph newBounds: wheel) center: self bounds corner - (3@0 * self width / 14); color: Color black).
	self addMorph: ((Morph newBounds: wheel) center: self bounds corner - (11@0 * self width / 14); color: Color black).! !

!GeoDSLCar methodsFor: 'private' stamp: 'hk 1/27/2014 16:37'!
privateBounds: boundsRect
	"bounds cannot be set at initialization time, thus we must intercept this morph method"
	super privateBounds: boundsRect.
	self initializeMorph
! !

Point subclass: #RoadPoint
	instanceVariableNames: 'bearing index speedlimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!RoadPoint commentStamp: '<historical>' prior: 0!
A NextPoint is a point and a direction (bearing).

Instance Variables
	bearing:		<Number>		- of the next point (index + 1) - in radians
	index: 			<Integer>		- of the reference point of the polygon array
	speedlimit:		<Integer>		- 0 if none
				
Note:
this bearing is in radians, not degrees.
the bearing of a point is its theta negated, it is counter-clockwise .!

!RoadPoint class methodsFor: 'as yet unclassified' stamp: 'hk 1/30/2014 17:35'!
from: aPoint at: index bearing:  radians
	^self from: aPoint at: index bearing:  radians speedlimit: 0! !

!RoadPoint class methodsFor: 'as yet unclassified' stamp: 'hk 1/30/2014 17:35'!
from: aPoint at: index bearing:  radians speedlimit: aNumber
	^(self x: aPoint x y: aPoint y)
		index: index;
		bearing: radians;
		speedlimit: aNumber ! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/28/2014 13:21'!
bearing
	^ bearing! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/28/2014 13:22'!
bearing: aRadian
	bearing := aRadian! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/28/2014 13:37'!
index
	^ index! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/28/2014 13:37'!
index: anInteger
	index := anInteger! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/31/2014 07:14'!
speedlimit
	^ speedlimit > 0 ifTrue: [ speedlimit ] ifFalse: [ 300 ]! !

!RoadPoint methodsFor: 'accessing' stamp: 'hk 1/30/2014 16:59'!
speedlimit: anInteger
	speedlimit := anInteger! !

Object subclass: #GeoDSLDrawing
	instanceVariableNames: 'realBounds screenBounds zoom translation objectDict canvas title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLDrawing commentStamp: '<historical>' prior: 0!
A GeoDSLDrawing holds all GeoDSLObjects.
It facilitates the coordinate transforms.

interface methods allow to add, remove and move objects (using their realWorld coordinates)

Instance Variables
	canvas:			<Morph>		- the morph that contains all other morphs
	objectDict:		<Dictionary>	- of all the named graphis objects
	realBounds:	<Rectangle>	- bounds of all objects in rela world
	screenBounds:	<Rectangle>	- bounds of all screen objects
	zoom:			<Number>		- scale of screen / realWorld
	translation:		<Object>		- of realWorld to screen (at 0@0)
	title:			<String>		- for transport from DSL-text to the window
!

!GeoDSLDrawing class methodsFor: 'instance creation' stamp: 'hk 1/20/2014 14:33'!
new: aString 
 	^self new initialize: aString! !

!GeoDSLDrawing methodsFor: 'inteface-basic' stamp: 'hk 2/13/2014 12:01'!
add: aGeoDSLObject
	"add a pre-fabricated GeoDSLObject"
	
	self addToObjectDict: aGeoDSLObject.
	self resetZoom.	
	canvas addMorph: (aGeoDSLObject asMorph) 
			
		! !

!GeoDSLDrawing methodsFor: 'interface-convenience' stamp: 'hk 1/27/2014 16:42'!
add: aMorphClass name: aString size: aSize at: aPoint 
	^self add: aMorphClass name: aString size: aSize at: aPoint bearing: 0 label: ''

! !

!GeoDSLDrawing methodsFor: 'interface-convenience' stamp: 'hk 2/13/2014 11:45'!
add: aMorphClass name: aString size: aSize at: aPoint bearing: aRadian label:  aString2
	"add a non-polygon object. my signature resembles the DSL grammar"
	self add:  ((GeoDSLObject new)
			morphClass: aMorphClass asSymbol;
			name: aString;
			size: aSize;
			location: aPoint;
			bearing: aRadian;
			label: aString2;
			yourself)                 
	
			
		! !

!GeoDSLDrawing methodsFor: 'interface-convenience' stamp: 'hk 2/13/2014 15:11'!
addPoly: aString vertices: anArray bearing: aRadian label:  aString2 closed: aBoolean
	"add a polygon. my signature resembles the DSL grammar"
	self add: ((GeoDSLPathshape vertices: anArray)
			morphClass: PolygonMorph name asSymbol;
			name: aString;
			bearing: aRadian;
			label: aString2;
			closed: aBoolean ;
			yourself)! !

!GeoDSLDrawing methodsFor: 'interface-convenience' stamp: 'hk 2/13/2014 15:13'!
addPoly: aString vertices: anArray closed: aBoolean
 	self addPoly: aString vertices: anArray bearing: 0 label:  '' closed: aBoolean
		! !

!GeoDSLDrawing methodsFor: 'parsing' stamp: 'hk 1/20/2014 19:56'!
addToObjectDict: aGeoDSLObject 
	(objectDict includesKey:  aGeoDSLObject name1)
		ifTrue: [ExampleBuilderMorph new abort:  'double names in GeoDSL' ].
	objectDict add: aGeoDSLObject name1 -> aGeoDSLObject.
	self mergeRealBounds: aGeoDSLObject realBounds.
	^ aGeoDSLObject! !

!GeoDSLDrawing methodsFor: 'accessing' stamp: 'hk 1/20/2014 14:38'!
canvas
	^ canvas! !

!GeoDSLDrawing methodsFor: 'interface-convenience' stamp: 'hk 2/13/2014 12:04'!
change: name at: property to: value 
	"convenience - change one of my GeoDSLObjects - ie the morph"
	|m|
	m := (self objectNamed: name) morph.
	"all morphs are wrapped by a TransformationMorph"
	(m firstSubmorph respondsTo: property) ifTrue: 
		[ ^ m firstSubmorph perform: property with: value ].
	(m  respondsTo: property) ifTrue: 
		[ m  perform: property with: value ].
	
 	
			
		! !

!GeoDSLDrawing methodsFor: 'parsing' stamp: 'hk 1/27/2014 13:04'!
createAllMorphsWithin: aPoint 
	screenBounds := 0 @ 0 extent: aPoint.
	self resetZoom.
	canvas addAllMorphs: (objectDict values collect: [:e | e asMorph ])  ! !

!GeoDSLDrawing methodsFor: 'initialize-release' stamp: 'hk 1/27/2014 13:52'!
initialize: aString 
	title := aString.
	canvas := PasteUpMorph new. 
	objectDict := Dictionary new

! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/26/2014 17:46'!
mergeRealBounds: aRectangle 
	realBounds ifNil: [ realBounds := aRectangle]
	ifNotNil: [realBounds := realBounds quickMerge: aRectangle]
	! !

!GeoDSLDrawing methodsFor: 'inteface-basic' stamp: 'hk 2/13/2014 11:57'!
morphNamed: aString 
	"answer the basic Morph of the named object"

	^(self objectNamed: aString) morph firstSubmorph 		
		! !

!GeoDSLDrawing methodsFor: 'interface-convenience' stamp: 'hk 2/13/2014 12:04'!
moveObject: aString To: aPoint bearing: degrees 
	(self objectNamed: aString) moveTo: aPoint bearing: degrees degreesToRadians zoom: zoom! !

!GeoDSLDrawing methodsFor: 'interface-convenience' stamp: 'hk 1/23/2014 16:57'!
moveObject: aString by: aNumber left: degrees 
	self moveObject: aString by: aNumber right: degrees negated! !

!GeoDSLDrawing methodsFor: 'interface-convenience' stamp: 'hk 2/13/2014 12:04'!
moveObject: aString by: aNumber right: degrees 
	(self objectNamed: aString) moveBy: aNumber right: degrees degreesToRadians zoom: zoom! !

!GeoDSLDrawing methodsFor: 'inteface-basic' stamp: 'hk 2/13/2014 11:59'!
objectNamed: aString 
	"basic access"
	
	^objectDict at: aString ifAbsent: [^self error: 'object ', aString, ' not found on remove' ]! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/26/2014 18:31'!
originalZoom
	^ (screenBounds width / realBounds width)
					min: (screenBounds height / realBounds height)
	! !

!GeoDSLDrawing methodsFor: 'inteface-basic' stamp: 'hk 2/13/2014 12:00'!
removeObjectNamed: aString 
	canvas removeMorph: (self objectNamed: aString) morph.
	objectDict removeKey: aString 
			
		! !

!GeoDSLDrawing methodsFor: 'actions' stamp: 'hk 1/26/2014 17:49'!
resetZoom
	self zoom: self originalZoom! !

!GeoDSLDrawing methodsFor: 'accessing' stamp: 'hk 1/27/2014 14:50'!
screenBounds
	^ screenBounds ! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/21/2014 14:18'!
setZoomTranslation
	objectDict valuesDo: [:o | o zoom: zoom translate: translation]! !

!GeoDSLDrawing methodsFor: 'inteface-basic' stamp: 'hk 2/13/2014 11:57'!
tMorphNamed: aString 
	"answer the transformationMorph of the named object"

	^(self objectNamed: aString) morph			
		! !

!GeoDSLDrawing methodsFor: 'accessing' stamp: 'hk 1/27/2014 11:49'!
title
	^ title! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/21/2014 16:46'!
translationWith: aZoom
	^ (aZoom * realBounds origin) rounded negated  + canvas bounds origin.

		! !

!GeoDSLDrawing methodsFor: 'accessing' stamp: 'hk 1/29/2014 14:15'!
zoom
	^ zoom ! !

!GeoDSLDrawing methodsFor: 'private' stamp: 'hk 1/23/2014 13:07'!
zoom: aZoom
	zoom := aZoom.
	translation := self translationWith: aZoom.
	"zoom all my objects"
	self setZoomTranslation! !

!GeoDSLDrawing methodsFor: 'actions' stamp: 'hk 1/21/2014 16:26'!
zoomIn
	self zoom: zoom * 1.5! !

!GeoDSLDrawing methodsFor: 'actions' stamp: 'hk 1/21/2014 16:27'!
zoomOut
	self zoom: zoom * 0.5! !

Object subclass: #GeoDSLModel
	instanceVariableNames: 'drawing window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLModel commentStamp: '<historical>' prior: 0!
A GeoDSLModel works with GeoDSLGrammar and GeoDSLCompiler

Instance Variables
	drawing:		<GeoDSLDrawing>
	window:		<StandardWindow>
!

GeoDSLModel subclass: #GeoDSLExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!GeoDSLExample commentStamp: '<historical>' prior: 0!
A GeoDSLExample holds som simple examples for the GeoDSL

!

!GeoDSLExample class methodsFor: 'examples' stamp: 'hk 2/11/2014 14:58'!
animation
	"self animation"
	|x|
	x := GeoDSLExample new createFrom: GeoDSLExample animationSpec.
	x drawing change: 'schrank' at: #color: to: Color lightBlue   .
	"flashing"	
	[5 timesRepeat:  
		[x drawing change: 'c1' at: #color: to: Color red. 
		x drawing change: 'c2' at: #color: to: Color green. 
		(Delay forSeconds: 1) wait.
		x drawing change: 'c1' at: #color: to: Color green . 
		x drawing change: 'c2' at: #color: to: Color red. 
		(Delay forSeconds: 1) wait
		] ] fork.
! !

!GeoDSLExample class methodsFor: 'geoSpec' stamp: 'hk 2/13/2014 12:14'!
animationSpec
	^ '      																				"GeoDSLExample new createFrom: self animationSpec"
	displayIn: myGraphics size: 1000@500    											"defines the initial zoom"
		(CircleMorph  c1 size: 20@20 at: 150@100 )   
		(CircleMorph  c2 size: 20@20 at: 250@100 )   
		(BorderedMorph  schrank size: 200@400 at: 200@250   label: ___________________schaltschrank)    
		"und noch n comment"
'! !

!GeoDSLExample class methodsFor: 'examples' stamp: 'hk 2/11/2014 11:40'!
example
	"self example"
	|x|
	x := GeoDSLExample new createFrom: GeoDSLExample geoSpec background: 'Nbgring.jpg'.
	"change existing objects"
	x drawing change: 'lane1' at: #color: to: Color lightBlue .
	x drawing change: 'lane2' at: #color: to: Color lightGreen  .
	x drawing change: 'lane2' at: #rotationDegrees: to: 10 .
	x drawing change: 'agv1' at: #color: to: Color lightBlue .
	x drawing change: 'agv2' at: #color: to: Color yellow  .
	"add an object"
	x drawing add: #GeoDSLCar  name: 'test1' size: 66@20 at: 100@200 bearing: 90 label: 'my Ferrari'. 
	x drawing change: 'test1' at: #rotationDegrees: to: 45 .
	"animate"
	[35 timesRepeat: [ (Delay forMilliseconds: 20) wait.  x drawing  moveObject: 'test1' by:  2 right: 1 ]] fork.
	[360 timesRepeat: [ (Delay forMilliseconds: 10) wait.  x drawing  moveObject: 'a1' by:  1.75 left: 1 ]] fork.
	"remove an object"
	[ (Delay forSeconds: 4 )wait.  x drawing removeObjectNamed: 'test1' ] fork! !

!GeoDSLExample class methodsFor: 'examples' stamp: 'hk 2/11/2014 14:16'!
exampleTrafficSimulation
	"GeoDSLExample exampleTrafficSimulation"
	TrafficSimulation newOn: TSRoad road1 with: 14
	
"	X  := TrafficSimulation newOn: TSRoad road1 with: 7
	[X     next] timeToRun
	MessageTally spyOn: [100 timesRepeat: [ X next ]] 

"! !

!GeoDSLExample class methodsFor: 'geoSpec' stamp: 'hk 2/13/2014 12:24'!
geoSpec
	^ '      																				"GeoDSLExample new createFrom: self geoSpec"
	displayIn: myGraphics size: 1000@500    											"defines the initial zoom"
		(BorderedMorph  lane1 size: 60@20 at: 300@100  bearing: 90   label: spur1)    "first object"
	   	(BorderedMorph  lane2 size: 60@20 at: 375@100 label: spur2 )				"second object"
		
		(BorderedMorph  agv1 size: 22@10 at: 500@150 bearing:  10 label: agv1)   	"third object"
		(BorderedMorph  agv2 size: 22@10 at: 500@180 bearing: 60 label: agv2 )   	"fourth object"
		
		(CircleMorph  c1 size: 200@200 at: 400@300 bearing: 1  label: the_circle)   	"fifth object"
		(GeoDSLCar  a1 size: 32@10 at: 500@300 bearing: 90  label: car1)   			"sixth object"
		(EllipseMorph  c2 size:  200@100 at: 400@300 bearing: 135 label: the_ellipse ) 
		
		(polygon: bla [200@200 250@220 300@250 230@270] label: border )
		(polyline: blb [200@300 250@320 300@350 230@370] label: line )		
'! !

!GeoDSLExample class methodsFor: 'geoSpec' stamp: 'hk 2/13/2014 12:46'!
geoSpecTrafficSimulation
		"GeoDSLExample new createFrom: self geoSpecTrafficSimulation"
^' displayIn: myGraphics size: 1100@550
		(BorderedMorph  corner1 size: 10@10 at: 4700@900 )	
	   	(BorderedMorph  corner2 size: 10@10 at: 5825@1605 ) 
		"comment"
'! !

!GeoDSLModel methodsFor: 'opening' stamp: 'hk 1/31/2014 11:56'!
addToolbarTo: aDock 
	aDock addMorph: self zoomToolbar .
! !

!GeoDSLModel methodsFor: 'initialize-release' stamp: 'hk 1/27/2014 14:55'!
createFrom: aSpec 
	self createFrom: aSpec background: nil! !

!GeoDSLModel methodsFor: 'initialize-release' stamp: 'hk 1/27/2014 17:24'!
createFrom: aSpec background: anImageFileOrNil 
	"comment stating purpose of message"
 
	drawing := GeoDSLCompiler compile: aSpec .
	window := StandardWindow labelled: drawing title.
	self decorateWindowWith: anImageFileOrNil .
	window  openInWorld.	! !

!GeoDSLModel methodsFor: 'opening' stamp: 'hk 1/31/2014 11:51'!
decorateWindow
	|  dock |
	dock := window newToolDockingBar.
	self addToolbarTo: dock .
	window
		addMorph: dock
		fullFrame: ((0 @ 0 corner: 1 @ 0.5) asLayoutFrame bottomOffset: dock minExtent y). 
	window addMorph: drawing canvas fullFrame: ((0@0 corner: 1@1) asLayoutFrame topOffset: dock minExtent y)

! !

!GeoDSLModel methodsFor: 'opening' stamp: 'hk 1/31/2014 11:34'!
decorateWindowWith: anImageFileOrNil
	self decorateWindow .
	anImageFileOrNil ifNotNil: 
		[drawing canvas backgroundMorph: ((Form fromFileNamed: anImageFileOrNil) scaledToSize: drawing screenBounds extent) asMorph].
	window themeChanged! !

!GeoDSLModel methodsFor: 'accessing' stamp: 'hk 1/23/2014 14:41'!
drawing
	^ drawing! !

!GeoDSLModel methodsFor: 'opening' stamp: 'hk 1/31/2014 11:59'!
zoomToolbar
	"subclasses add here"
	^window newToolbar: 
				{window
					newButtonFor: drawing
					getState: nil
					action: #zoomIn
					arguments: nil
					getEnabled: nil
					label: 'zoom in'
					help: 'zoom in by a certain amount'. 
				window
					newButtonFor: drawing
					getState: nil
					action: #zoomOut
					arguments: nil
					getEnabled: nil
					label: 'zoom out'
					help: 'zoom out by a certain amount'.
				window
					newButtonFor: drawing
					getState: nil
					action: #resetZoom
					arguments: nil
					getEnabled: nil
					label: 'reset zoom'
					help: 'zoom to original'}

! !

GeoDSLModel subclass: #TrafficSimulation
	instanceVariableNames: 'cars road tick running wait'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!TrafficSimulation commentStamp: '<historical>' prior: 0!
A TrafficSimulation is an example for the GeoDSL.
It demonstrates the traffic phase transition from free flow to congestion when the car density becomes too high for a certain velocity. 

Instance Variables
	cars:				<OrderedCollection of TSCar>
	road:				<TSRoad>
	tick:				<Integer>			- simulation tick distance in milliseconds
	wait:				<Integer>			- tick - wait = execution time
	running:			<Boolean>			- toggle											  
			!

!TrafficSimulation class methodsFor: 'as yet unclassified' stamp: 'hk 1/28/2014 16:44'!
newOn: aTSRoad with: noOfCars
 	^(self new)
		road: aTSRoad;
		cars: noOfCars;
		open
		! !

!TrafficSimulation methodsFor: 'opening' stamp: 'hk 1/31/2014 13:35'!
addToolbarTo: aDock 
	aDock addMorph: self carToolbar .
	aDock addMorph: self simulationToolbar .
	super addToolbarTo: aDock ! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/30/2014 15:15'!
carAt: index 
	"modulo - assuming a circular list"  
	^cars at: ((index - 1 + cars size) \\ cars size) + 1! !

!TrafficSimulation methodsFor: 'opening' stamp: 'hk 1/31/2014 13:34'!
carToolbar
 ^window newToolbar: { 
		window
			newButtonFor: self
			getState: nil
			action: #sleep
			arguments: nil
			getEnabled: nil
			label: 'sleep'
			help: 'driver go to sleep for once'. 
		window
			newButtonFor: self
			getState: nil
			action: #stopFirstCar
			arguments: nil
			getEnabled: nil
			label: 'stop car 1'
			help: 'stops the first car'. 
		window
			newButtonFor: self
			getState: nil
			action: #letGoFirstCar
			arguments: nil
			getEnabled: nil
			label: 'go car 1'
			help: 'lets the first car go'. }
! !

!TrafficSimulation methodsFor: 'initialize-release' stamp: 'hk 1/31/2014 13:00'!
cars: aNumber 
	1 to: aNumber do: 
		[:i | |c|
		c := TSCar newOn: self.
		c name: 'c', i asString.
		c label: ''.
		c carIndex: i.
		cars addLast: c]! !

!TrafficSimulation methodsFor: 'initialize-release' stamp: 'hk 2/11/2014 14:02'!
initialize 
	cars := OrderedCollection new.
	tick := 20.
	wait := 0. 	"tick - wait = execution time"
	running := false! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/31/2014 13:21'!
letGoFirstCar
	(cars at:  1) initializeVelocities ! !

!TrafficSimulation methodsFor: 'simulation' stamp: 'hk 1/30/2014 18:05'!
next
	cars do: [ :e | e next ]! !

!TrafficSimulation methodsFor: 'opening' stamp: 'hk 1/30/2014 13:17'!
open 
		
	self createFrom: GeoDSLExample geoSpecTrafficSimulation background: 'Nbgring.jpg'.
	drawing add:  road.
	cars do: [ :e | e location: (5000@950). drawing add: e ]

! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/28/2014 15:56'!
road
	^ road! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/28/2014 16:06'!
road: aTSRoad 
	road := aTSRoad! !

!TrafficSimulation methodsFor: 'simulation' stamp: 'hk 1/31/2014 06:33'!
run
	running := true.
	[[running] whileTrue: 
		[self next. 
		Processor yield.
		(Delay forMilliseconds: wait) wait]] fork! !

!TrafficSimulation methodsFor: 'simulation' stamp: 'hk 1/30/2014 18:06'!
run: aTick
	tick := aTick.
	self run! !

!TrafficSimulation methodsFor: 'opening' stamp: 'hk 1/31/2014 13:34'!
simulationToolbar
 ^window newToolbar: 
		{window
			newButtonFor: self
			getState: nil
			action: #run
			arguments: nil
			getEnabled: nil
			label: 'run'
			help: 'start simulation'. 
		window
			newButtonFor: self
			getState: nil
			action: #stop
			arguments: nil
			getEnabled: nil
			label: 'stop'
			help: 'stops simulation'.
		window
			newButtonFor: self
			getState: nil
			action: #inspect
			arguments: nil
			getEnabled: nil
			label: 'inspect'
			help: 'open inspector'.  }
! !

!TrafficSimulation methodsFor: 'simulation' stamp: 'hk 1/31/2014 13:40'!
sleep
	cars do: [ :e | e sleepTime: 5000 ]! !

!TrafficSimulation methodsFor: 'simulation' stamp: 'hk 1/30/2014 18:03'!
stop
	running := false
! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/31/2014 13:12'!
stopFirstCar
	(cars at:  1) stop! !

!TrafficSimulation methodsFor: 'accessing' stamp: 'hk 1/28/2014 21:02'!
tick
	^ tick! !

Object subclass: #GeoDSLObject
	instanceVariableNames: 'morphClass name label morph location size bearing screenLocation screenSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLObject commentStamp: '<historical>' prior: 0!
A GeoDSLObject stores the real world information of an object in a GeoDSL application.
In addition it stores all information that is needed by the GeoDSL parser to create its morph.

Instance Variables
	label:				<String>
	morphClass:		<ClassName>
	name:				<String>
	morph:				<Morph>
	screenLocation:	<Point>			center of bounds
	screenSize:		<Point>			extent of bounds


label
	- the displayed name of the object

morphClass
	- needed for creation of the morph (GeoDSLOther>>asMorph)

name
	- for programmed reference
!

!GeoDSLObject methodsFor: 'private' stamp: 'hk 1/27/2014 13:01'!
asBasicMorph
	"answer the bare morph that I describe"
	|m|
	m := (Smalltalk at: morphClass) newBounds: (0@0 extent: screenSize ).
	m center: screenLocation.
	self attribute: m.
	^ m! !

!GeoDSLObject methodsFor: 'converting' stamp: 'hk 1/27/2014 13:12'!
asMorph
	^morph := self asTransformationMorph! !

!GeoDSLObject methodsFor: 'private' stamp: 'hk 1/27/2014 13:12'!
asTransformationMorph
	"wrap the bare morph by ist transformation"
	|m|
	m := TransformationMorph new asFlexOf: self asBasicMorph.
	m angle: bearing.
	m name: name.
	^ m! !

!GeoDSLObject methodsFor: 'private' stamp: 'hk 1/23/2014 10:28'!
attribute: aMorph
	aMorph name:  name.
	aMorph addMorph: 
		(label asTextMorph position: aMorph position)
	! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 2/13/2014 16:26'!
bearing
	^bearing ! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/21/2014 17:33'!
bearing: aNumber
	bearing := aNumber! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/19/2014 19:26'!
label: anObject
	label := anObject! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/29/2014 15:52'!
location
	^location! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/21/2014 17:33'!
location: aPoint
	location := aPoint! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/27/2014 17:40'!
morph
	^morph ! !

!GeoDSLObject methodsFor: 'parsing-interface' stamp: 'hk 1/19/2014 19:31'!
morphClass: aClassName
	morphClass := aClassName! !

!GeoDSLObject methodsFor: 'parsing-interface' stamp: 'hk 1/29/2014 12:57'!
moveBy: aNumber right: aRadian zoom: aZoom
	"move and turn differentially"
	| delta |
	delta := Point radius: aNumber theta: bearing negated.
	location := location + delta.
	bearing := bearing - aRadian.
	bearing := bearing \\ (2 * Float pi).			"keep bearing within 2 pi"
	morph position:  (morph position) + (delta * aZoom).
"	screenLocation := morph center.			not sure that we need this"
	morph angle: bearing

! !

!GeoDSLObject methodsFor: 'parsing-interface' stamp: 'hk 2/11/2014 13:36'!
moveTo: aPoint bearing: aRadian zoom: aZoom
	"move and turn absolutely"
	| delta |
	"move the object"
	delta := aPoint - location.
	location := aPoint.
	bearing := aRadian.
	"move the morph"
	morph angle: bearing.
	morph position:  (morph position) + (delta * aZoom).

"	screenLocation := morph center.			not sure that we need this"
				
				

! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/20/2014 17:00'!
name1
	^name ! !

!GeoDSLObject methodsFor: 'private' stamp: 'hk 1/20/2014 13:57'!
name: aString
	name := aString! !

!GeoDSLObject methodsFor: 'zoom & translation' stamp: 'hk 1/21/2014 17:34'!
realBounds
	^ location - (size / 2) extent: size ! !

!GeoDSLObject methodsFor: 'accessing' stamp: 'hk 1/21/2014 17:33'!
size: aPoint
	size := aPoint! !

!GeoDSLObject methodsFor: 'zoom & translation' stamp: 'hk 1/27/2014 18:44'!
zoom: aNumber translate: aPoint 
	screenLocation := (location * aNumber + aPoint) rounded.
	screenSize := (size * aNumber) rounded.
	morph ifNotNil: [self zoomMorph]! !

!GeoDSLObject methodsFor: 'zoom & translation' stamp: 'hk 1/27/2014 13:18'!
zoomMorph
	morph bounds: (self asTransformationMorph bounds).
	morph center: screenLocation! !

GeoDSLObject subclass: #GeoDSLPathshape
	instanceVariableNames: 'points closed screenPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL'!

!GeoDSLPathshape commentStamp: '<historical>' prior: 0!
A GeoDSLPathshape represents polygons and polylines.

Instance Variables
	points:			<Array>
	screenPoints:	<Array>
	closed:			<Boolean>

closed
	- true for Polygon, false for Polyline

points
	- my real world points
!

!GeoDSLPathshape class methodsFor: 'instance creation' stamp: 'hk 2/13/2014 14:48'!
vertices: anArrayOfPoints 
	"self vertices: ( Array with: 0@0 with: 1@1 with: 2@2)"
	^ self vertices: anArrayOfPoints closed: false! !

!GeoDSLPathshape class methodsFor: 'instance creation' stamp: 'hk 2/13/2014 14:47'!
vertices: anArrayOfPoints closed: aBoolean
	"self vertices: ( Array with: 0@0 with: 1@1 with: 2@2)"
	^ self new initWithPoints: anArrayOfPoints closed: aBoolean! !

!GeoDSLPathshape methodsFor: 'converting' stamp: 'hk 1/27/2014 17:50'!
asBasicMorph
	"answer the bare morph that I describe"
	|m|
	m := PolygonMorph
				vertices: screenPoints
				color: Color transparent
				borderWidth: 1
				borderColor: Color black.
	closed ifTrue: [m makeClosed] ifFalse: [ m makeOpen  ].
	self attribute: m.
	^ m! !

!GeoDSLPathshape methodsFor: 'parsing-interface' stamp: 'hk 2/13/2014 14:51'!
closed
	^closed ! !

!GeoDSLPathshape methodsFor: 'parsing-interface' stamp: 'hk 1/19/2014 19:26'!
closed: aBoolean
	closed := aBoolean! !

!GeoDSLPathshape methodsFor: 'initialize-release' stamp: 'hk 2/13/2014 14:47'!
initWithPoints: anArrayOfPoints closed: aBoolean
	points := anArrayOfPoints.
	size := self realBounds extent.
	location := self realBounds  center.
	morphClass := PolygonMorph name asSymbol.
	closed := aBoolean! !

!GeoDSLPathshape methodsFor: 'accessing' stamp: 'hk 1/20/2014 17:18'!
realBounds
	^(PathShape  vertices: points ) bounds! !

!GeoDSLPathshape methodsFor: 'zoom & translation' stamp: 'hk 1/23/2014 10:40'!
zoom: aNumber translate: aPoint 
	screenPoints := points collect: [ :e | e * aNumber + aPoint ].
	super zoom: aNumber translate: aPoint ! !

GeoDSLPathshape subclass: #TSRoad
	instanceVariableNames: 'roadMaxV'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!TSRoad commentStamp: '<historical>' prior: 0!
A TSRoad is the road in the TrafficSimulation.

Instance Variables
	roadMaxV:		<Array of Number|nil>		- the maxV signs (same size as points)

!

!TSRoad class methodsFor: 'roads' stamp: 'hk 1/28/2014 17:07'!
pointsRoad1
	"self road1"  "almost an oval using 64 points"
 ^{	Point x: 5000 y: 1000 .
	Point x: 5050 y: 1000 .
	Point x: 5100 y: 1000 .
	Point x: 5150 y: 1000 .
	Point x: 5200 y: 1000 .
	Point x: 5250 y: 1000 .
	Point x: 5300 y: 1000 .
	Point x: 5350 y: 1000 .
	Point x: 5400 y: 1000 .
	Point x: 5450 y: 1000 .
	Point x: 5500 y: 1000 .
	Point x: 5550 y: 1000 .
	Point x: 5590 y: 1010 .
	Point x: 5630 y: 1020 .
	Point x: 5660 y: 1040 .
	Point x: 5690 y: 1060 .
	Point x: 5710 y: 1090 .
	Point x: 5730 y: 1120 .
	Point x: 5740 y: 1160 .
	Point x: 5750 y: 1200 .
	Point x: 5750 y: 1250 .
	Point x: 5750 y: 1300 .
	Point x: 5740 y: 1340 .
	Point x: 5730 y: 1380 .
	Point x: 5710 y: 1410 .
	Point x: 5690 y: 1440 .
	Point x: 5660 y: 1460 .
	Point x: 5630 y: 1480 .
	Point x: 5590 y: 1490 .
	Point x: 5550 y: 1500 .
	Point x: 5500 y: 1500 .
	Point x: 5450 y: 1500 .
	Point x: 5400 y: 1500 .
	Point x: 5350 y: 1500 .
	Point x: 5300 y: 1490 .
	Point x: 5250 y: 1480 .
	Point x: 5200 y: 1470 .
	Point x: 5150 y: 1460 .
	Point x: 5100 y: 1450 .
	Point x: 5050 y: 1440 .
	Point x: 5000 y: 1430 .
	Point x: 4960 y: 1420 .
	Point x: 4920 y: 1410 .
	Point x: 4890 y: 1400 .
	Point x: 4860 y: 1390 .
	Point x: 4840 y: 1380 .
	Point x: 4820 y: 1360 .
	Point x: 4810 y: 1340 .
	Point x: 4800 y: 1310 .
	Point x: 4800 y: 1290 .
	Point x: 4810 y: 1260 .
	Point x: 4820 y: 1230 .
	Point x: 4840 y: 1190 .
	Point x: 4860 y: 1150 .
	Point x: 4880 y: 1120 .
	Point x: 4900 y: 1090 .
	Point x: 4920 y: 1070 .
	Point x: 4930 y: 1050 .
	Point x: 4940 y: 1040 .
	Point x: 4950 y: 1030 .
	Point x: 4960 y: 1020 .
	Point x: 4970 y: 1012 .
	Point x: 4980 y: 1006 .
	Point x: 4990 y: 1002 
}! !

!TSRoad class methodsFor: 'instance creation' stamp: 'hk 2/13/2014 14:49'!
road1
	^(self new)
		initWithPoints:  self pointsRoad1 closed: true;
		initRoadPointsWithSpeedLimits: self speedLimits1 ;
		name: 'road1' 
		! !

!TSRoad class methodsFor: 'roads' stamp: 'hk 2/10/2014 19:27'!
speedLimits1
	"self speedLimits1"  "speed limits for road1 0 =  no limit"
 	| sl |
	sl := (IntegerArray ofSize: self pointsRoad1 size).
	60 to: 63 do: [:i | sl at: i put:  0"7" ] .	"20 km/h"
	^sl
	! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/30/2014 13:42'!
index: index behind: otherIndex 
	"i am only behind if otherIndex is not greater than half the road"
	^ (otherIndex - index + points size \\ points size) < (points size / 2)! !

!TSRoad methodsFor: 'initialize-release' stamp: 'hk 1/31/2014 12:23'!
initRoadPointsWithSpeedLimits: anArray 
	"converts the road points 'points' and adds the speedlimits"
	| nextPoint |
	anArray size = points size
		ifFalse: [self error: 'wrong size of ' , anArray printString].
	nextPoint := points first. 
	(1 to: points size) reverseDo: 
			[:i | | e b n |
			e := points at: i.
			b := ((nextPoint) - e) theta negated.
			nextPoint := e.
			n := RoadPoint
					from: e
					at: i
					bearing: b
					speedlimit: (anArray at: i).
			points at: i put: n]! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/29/2014 14:49'!
initialPosition 
	^self roadPointAt: 1! !

!TSRoad methodsFor: 'initialize-release' stamp: 'hk 1/28/2014 17:11'!
initialize 
	"I must be initialized carefully since I am used directly in GeoDSLDrawing"
	closed := true.
	bearing := 0.
	label := ''.
	morphClass := #PolygonMorph! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/30/2014 14:32'!
nextIndexOf: index 
	"modulo"
	^ (index \\ points size) + 1 ! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/30/2014 11:43'!
nextPositionFor: distance From: aPoint at: index 

	| nextP nextI r |
	nextI := self nextIndexOf: index.
	nextP :=  points at: nextI. 
	r := (nextP - aPoint) r. 
	(r > distance ) ifTrue: [ ^self roadPoint: aPoint + ((nextP - aPoint) * distance / r) at: index].
	(r < distance ) ifTrue: [^self nextPositionFor: distance-r From: nextP at: nextI ] .
	(r = distance ) ifTrue: [ ^self roadPointAt: nextI ]
	! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/30/2014 12:31'!
roadPoint: aPoint at: index 
	| nextIndex |
	nextIndex := self nextIndexOf: index.
	^RoadPoint from: aPoint at: index bearing:  ((points at: nextIndex) - aPoint ) theta negated! !

!TSRoad methodsFor: 'simulation' stamp: 'hk 1/31/2014 12:43'!
roadPointAt: index 
	^ points at: index
! !

GeoDSLObject subclass: #TSCar
	instanceVariableNames: 'a d maxV v ts carIndex roadIndex minDistance sleeptime timeToAwake'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GeoDSL-Examples'!

!TSCar commentStamp: '<historical>' prior: 0!
A TSCar is a car in the TrafficSimulation.

Instance Variables
	a:					<Number>			- acceleration in m/s^2
	d:					<Number>			- de-acceleration in m/s^2
	minDistance:		<Number>			- physical distance - not crashed
	maxV:				<Number>			- of the car
	ts:					<TrafficSimulation> 
	v:					<Number>			- actual velocity of the car
	sleeptime:			<Integer>			- in milliseconds
	carIndex:			<Integer>			- in the collection of cars
	roadIndex:			<Integer>			- in the road. 0 = offRoad
!

!TSCar class methodsFor: 'as yet unclassified' stamp: 'hk 1/28/2014 12:56'!
newOn: aTrafficSimulation 
	^(self new) ts: aTrafficSimulation ! !

!TSCar methodsFor: 'simulation' stamp: 'hk 2/11/2014 13:48'!
accelerate
	(timeToAwake  > 0 ) ifTrue: [ timeToAwake := timeToAwake - ts tick ] ifFalse:
	[v := maxV min: (v + (a * ts tick /1000)) asFloat ]! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/31/2014 12:43'!
adjustV
	"answer my new v. if possible i am accelerated"
	self frontDistance < minDistance ifTrue: [^ self crash].
	(ts road roadPointAt: roadIndex) speedlimit < v ifTrue: [ ^ self decelerate].
	"the distance rule is d=0"
	self frontDistance - (v / 2) - minDistance > 0 ifTrue: [^ self accelerate].	
	^ self decelerate! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 12:48'!
carInFront
	^ts carAt: carIndex - 1! !

!TSCar methodsFor: 'accessing' stamp: 'hk 1/29/2014 11:32'!
carIndex:  anInteger
	carIndex := anInteger! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/31/2014 13:17'!
crash
	'crash' halt.
	v := 0! !

!TSCar methodsFor: 'simulation' stamp: 'hk 2/11/2014 13:55'!
decelerate
	v := (v + (d * ts tick /1000) ) max: 0.
	(v=0) ifTrue: [ timeToAwake := sleeptime ]
! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/31/2014 07:04'!
distanceToGo
	"answer the distance to go with new v"
	self adjustV  .
	^v * ts tick / 1000
! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 21:03'!
frontDistance
	"distance to car in front or > maxV/2. we neglect curves"
	self carInFront onroad ifFalse: [^maxV/2+minDistance ].
	(ts road index: roadIndex  behind: self carInFront roadIndex ) 
		ifTrue: [^(self carInFront location - location) r ]
		ifFalse: [ ^maxV/2+minDistance ]
! !

!TSCar methodsFor: 'initialize-release' stamp: 'hk 2/11/2014 14:02'!
initialize
	self initializeVelocities .
	sleeptime := 0.
	timeToAwake  := 0.
	minDistance := 20. "m"
	v := 0.	"m/s^2"
	roadIndex := 0.  "offroad"
	"init super instance vars"
	morphClass := #GeoDSLCar.
	size := 40 @ 8.	"m"
	name := ''.
	label := ''.
	bearing := 0.! !

!TSCar methodsFor: 'initialize-release' stamp: 'hk 2/11/2014 14:05'!
initializeVelocities
	a := 4. 	"m/s^2"
	d := -8.	"m/s^2"
	maxV := 40.	"m/s"
! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/31/2014 13:50'!
move
	"advance me as far as can be - distanceToGo"
	| p | 
	self frontDistance  > minDistance  ifTrue: 
		[ p := ts road nextPositionFor: self distanceToGo  From: location  at: roadIndex .
		 self moveTo: p ] ifFalse: [ v := 0 ]! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/29/2014 17:57'!
moveTo: aRoadPoint
	self moveTo: aRoadPoint  bearing: aRoadPoint bearing zoom:  ts drawing zoom .  
	roadIndex := aRoadPoint index ! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/29/2014 17:53'!
next
	self onroad ifFalse: [ ^self putOnRoad ].
	self move.! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/29/2014 17:42'!
onroad
	^(roadIndex = 0) not! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/30/2014 12:56'!
putOnRoad
	"put me at the road initial position if empty. do nothing if occupied"
	| p | 
	p := ts road initialPosition.
	"start with first car"  
	carIndex = 1 ifTrue: [ ^self moveTo: p].
	self carInFront onroad ifFalse: [ ^self ].
	self carInFront location = p ifFalse: [ self moveTo: p ].
! !

!TSCar methodsFor: 'accessing' stamp: 'hk 1/30/2014 13:41'!
roadIndex
	^roadIndex! !

!TSCar methodsFor: 'accessing' stamp: 'hk 1/31/2014 06:47'!
sleepTime: milliSeconds
	sleeptime := milliSeconds 
	! !

!TSCar methodsFor: 'simulation' stamp: 'hk 1/31/2014 13:19'!
stop
	maxV  := 0! !

!TSCar methodsFor: 'accessing' stamp: 'hk 1/28/2014 12:56'!
ts: aTrafficSimulation
	ts := aTrafficSimulation! !
